/*
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This is copyright (2007-2009) by the Broad Institute/Massachusetts Institute 
 * of Technology.  It is licensed to You under the Gnu Public License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *    http://www.opensource.org/licenses/gpl-2.0.php
 *
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 * use, misuse, or functionality.
 */

/*
 * TrackRenderer.java
 *
 * Created on Sep 6, 2007, 10:07:39 AM
 *
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.broad.igv.renderer;

import java.awt.Color;
import org.broad.igv.track.RenderContext;

/**
 *
 * @author jrobinso
 */
public class BarChartRenderer extends XYPlotRenderer {

    @Override
    public String getDisplayName() {
        return "Bar Chart";
    }

    /**
     * Render the data track as a bar chart.
     *
     */
    @Override
    protected void drawDataPoint(Color graphColor, int dx, int pX, int baseY, int pY, RenderContext context) {
        //if (pY != baseY) {
        if (dx <= 1)
        {
            context.getGraphic2DForColor(graphColor).drawLine(pX, baseY, pX, pY);
        } else
        {
            if (pY > baseY)
            {
                context.getGraphic2DForColor(graphColor).fillRect(pX, baseY, dx, pY - baseY);
            } else
            {
                context.getGraphic2DForColor(graphColor).fillRect(pX, pY, dx, baseY - pY);
            }
        }
    //}
    }
}
