/*
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This is copyright (2007-2009) by the Broad Institute/Massachusetts Institute 
 * of Technology.  It is licensed to You under the Gnu Public License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *    http://www.opensource.org/licenses/gpl-2.0.php
 *
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 * use, misuse, or functionality.
 */

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.broad.igv.renderer;

/**
 *
 * @author jrobinso
 */
public class ColorScaleFactory {

    public static ColorScale getScaleFromString(String string) {

        String[] tokens = string.split(";");
        if (tokens[0].trim().equals(ContinuousColorScale.serializedClassName)) {
            return new ContinuousColorScale(string);
        } else if (tokens[0].trim().equals(MappedColorScale.serializationClassId)) {
            return new MappedColorScale(string);
        }
        throw new RuntimeException("Illegal ColorScale: " + string);
    }

}
