/*
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This is copyright (2007-2009) by the Broad Institute/Massachusetts Institute
 * of Technology.  It is licensed to You under the Gnu Public License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *    http://www.opensource.org/licenses/gpl-2.0.php
 *
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 * use, misuse, or functionality.
*/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.broad.igv.sam;


public class ReadMate {

    String mateChr;
    int mateStart;
    boolean negativeStrand;
    boolean mapped;

    public ReadMate(String mateChr, int mateStart, boolean negativeStrand,
            boolean isReadUnmappedFlag) {
        this.mateChr = mateChr;
        this.mateStart = mateStart;
        this.negativeStrand = negativeStrand;
        this.mapped = !isReadUnmappedFlag && !mateChr.equals("*");
    }

    public boolean isMapped() {
        return mapped;
    }

    public String toString() {
        return mateChr + ":" + mateStart + " (" + (negativeStrand ? "-" : "+") + ")";
    }

    public String getLocus() {
        return mateChr + ":" + mateStart;
    }
}
