/*
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This is copyright (2007-2009) by the Broad Institute/Massachusetts Institute 
 * of Technology.  It is licensed to You under the Gnu Public License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *    http://www.opensource.org/licenses/gpl-2.0.php
 *
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 * use, misuse, or functionality.
*/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.broad.igv.ui;

/**
 *
 * @author eflakes
 */
public class UIConstants {

    // General
    final static public String CLICK_ITEM_TO_EDIT_TOOLTIP = 
        "Click this item bring up its editor";

    // Toolbar Menu Item Tooltips
    final static public String JUMP_TO_WHOLE_GENOME_VIEW_TOOLTIP = 
        "Jump to whole genome view";
    final static public String JUMP_TO_LOCUS_TOOLTIP = 
        "Jump to Gene or Locus";
    final static public String SELECT_CHROMOSOME_TOOLTIP = 
        "Select a chromosome to view";
    final static public String ZOOM_TOOL_TOOLTIP = 
        "Click + to zoom in - Click - to zoom out";
    

    // File Menu Item Tooltips
    final static public String LOAD_TRACKS_TOOLTIP = 
        "Load data, features or sample information";
    final static public String LOAD_SERVER_DATA_TOOLTIP =
        "Load data, features or sample information from a server";
    final static public String LOAD_ATTRIBUTES_TOOLTIP = 
        "Load track attributes";
    final static public String SAVE_IMAGE_TOOLTIP = 
        "Capture and save an image";
    final static public String NEW_SESSION_TOOLTIP = 
        "Create a new session";
    final static public String SAVE_SESSION_TOOLTIP = 
        "Save the current session";
    final static public String SAVE_SESSION_AS_TOOLTIP = 
        "Save the current session to the specified file";
    final static public String RESTORE_SESSION_TOOLTIP = 
        "Reload the named session";
    final static public String EXIT_TOOLTIP = 
        "Exit the application";
    final static public String EXPORT_REGION_TOOLTIP = 
        "Allows currently selected regions to be exported to a file";
    final static public String IMPORT_REGION_TOOLTIP = 
        "Allows previously exported regions to be reloaded";

    // Edit Menu Item Tooltips
    final static public String CHANGE_GENOME_TOOLTIP = 
        "Switch the current genome";
    final static public String IMPORT_GENOME_TOOLTIP = 
        "Create a user-defined genome and makes it available for use in the application";
    final static public String LOAD_GENOME_TOOLTIP = 
        "Make an externally defined genome available for use in the application";
    final static public String REMOVE_USER_DEFINE_GENOME_TOOLTIP = 
        "Removes user-defined genomes from the drop-down list";
    final static public String CLEAR_GENOME_CACHE_TOOLTIP = 
        "Clears locally cached versions of IGV hosted genomes.";

    // View Menu Item Tooltips
    final static public String PREFERENCE_TOOLTIP = 
        "Set user specific preferences";
    final static public String SHOW_ATTRIBUTE_DISPLAY_TOOLTIP = 
        "Show or hide the attribute display";
    final static public String ENABLE_REGIONS_OF_INTEREST_TOOLTIP = 
        "Enable the \"Region of Interest\" tool";
    final static public String REFRESH_TOOLTIP = 
        "Refresh the application's display";
    final static public String SHOW_HEATMAP_LEGEND_TOOLTIP = 
        "View or edit color legends and scales";
    final static public String SELECT_DISPLAYABLE_ATTRIBUTES_TOOLTIP = 
        "Customize attribute display to show only checked attributes";
    final static public String USE_IMAGE_CACHING_TOOLTIP = 
        "Use image caching to improve display performance";
    final static public String DIRECT_DRAW_DISABLED_TOOLTIP = 
        "Checked this item to prevent the use of direct draw" +
        " when rendering images - Uncheck it to use the default system behavior";

    // Tracks Menu Item Tooltips
    final static public String SORT_TRACKS_TOOLTIP = 
        "Sort tracks by attribute value";
    final static public String GROUP_TRACKS_TOOLTIP = 
        "Group tracks";
    final static public String FILTER_TRACKS_TOOLTIP = 
        "Filter tracks by attribute value";
    final static public String RESET_DEFAULT_TRACK_HEIGHT_TOOLTIP = 
        "Reset all track to the default track height";
    final static public String SET_DEFAULT_TRACK_HEIGHT_TOOLTIP = 
        "Set the height for all tracks";
    final static public String FIT_DATA_TO_WINDOW_TOOLTIP =
        "Resizes all track heights in order to make all tracks visible in " +
        "their display with no vertical scrolling";

    // Help Menu Item Tooltips
    final static public String HELP_TOOLTIP = 
        "Open web help page";
    final static public String TUTORIAL_TOOLTIP = 
        "Open tutorial web page";
    final static public String ABOUT_TOOLTIP = 
        "Display application information";
    
    // Tool Menu
    final static public String MACRO_SNAPSHOTS =
        "Macro Snapshots";
    final static public String RESET_FACTORY_TOOLTIP = 
        "Restores all user preferences to their default settings.";
}

