/*
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This is copyright (2007-2009) by the Broad Institute/Massachusetts Institute
 * of Technology.  It is licensed to You under the Gnu Public License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *    http://www.opensource.org/licenses/gpl-2.0.php
 *
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 * use, misuse, or functionality.
*/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.broad.igv.ui.panel;

import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author jrobinso
 */
public class DragEventManager {

    Set<DragListener> dragListeners;

    static private DragEventManager instance;
    
    public static synchronized DragEventManager getInstance() {
        if(instance == null) {
            instance = new DragEventManager();
        }
        return instance;
    }

    private DragEventManager() {
        dragListeners = new HashSet();

    }

    public void addDragListener(DragListener listener) {
        dragListeners.add(listener);
    }

    public void removeDragListener(DragListener listener) {
        dragListeners.remove(listener);
    }

    public void dragStopped() {
        if (!dragListeners.isEmpty()) {
            DragEvent evt = new DragEvent();
            for (DragListener l : dragListeners) {
                l.dragStopped(evt);
            }
        }

    }
}
